package edu.mermet.tp8.aide;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;

public class ConfigDialog extends JDialog {

    JLabel conversion;
    JLabel saisie;
    JLabel diaporama;
    JLabel boutons;

    JButton validerBouton;
    JButton annulerBouton;

    public ConfigDialog(JFrame owner){
        super(owner, true);
        setTitle("Configuration des menus");
        init();
        setSize(new Dimension(400,200));
        setLocationRelativeTo(null);
        setVisible(true);
    }

    private void init() {

        conversion = new JLabel("Conversion ");
        saisie = new JLabel("Saisie de texte");
        diaporama = new JLabel("Diaporama");
        boutons = new JLabel("Boutons");

        validerBouton = new JButton(new ValiderButton());
        annulerBouton = new JButton(new AnnulerButton());

        JPanel paneauCentral = new JPanel();
        paneauCentral.setLayout(new BoxLayout(paneauCentral, BoxLayout.Y_AXIS));

        JPanel conversionPane = new JPanel();
        ButtonGroup conversionGroup = new ButtonGroup();
        JRadioButton conversionAuto = new JRadioButton("Auto");
        JRadioButton conversionAffiche = new JRadioButton("Affiché");
        JRadioButton conversionCache = new JRadioButton("Caché");
        conversionGroup.add(conversionAuto);
        conversionGroup.add(conversionAffiche);
        conversionGroup.add(conversionCache);
        conversionPane.add(conversion);
        conversionPane.add(conversionAuto);
        conversionPane.add(conversionAffiche);
        conversionPane.add(conversionCache);

        JPanel saisiePane = new JPanel();
        ButtonGroup saisieGroup = new ButtonGroup();
        JRadioButton saisieAuto = new JRadioButton("Auto");
        JRadioButton saisieAffiche = new JRadioButton("Affiché");
        JRadioButton saisieCache = new JRadioButton("Caché");
        saisieGroup.add(saisieAuto);
        saisieGroup.add(saisieAffiche);
        saisieGroup.add(saisieCache);
        saisiePane.add(saisie);
        saisiePane.add(saisieAuto);
        saisiePane.add(saisieAffiche);
        saisiePane.add(saisieCache);

        JPanel diaporamaPane = new JPanel();
        ButtonGroup diaporamaGroup = new ButtonGroup();
        JRadioButton diaporamaAuto = new JRadioButton("Auto");
        JRadioButton diaporamaAffiche = new JRadioButton("Affiché");
        JRadioButton diaporamaCache = new JRadioButton("Caché");
        diaporamaGroup.add(diaporamaAuto);
        diaporamaGroup.add(diaporamaAffiche);
        diaporamaGroup.add(diaporamaCache);
        diaporamaPane.add(diaporama);
        diaporamaPane.add(diaporamaAuto);
        diaporamaPane.add(diaporamaAffiche);
        diaporamaPane.add(diaporamaCache);

        JPanel boutonsPane = new JPanel();
        ButtonGroup boutonsGroup = new ButtonGroup();
        JRadioButton boutonsAuto = new JRadioButton("Auto");
        JRadioButton boutonsAffiche = new JRadioButton("Affiché");
        JRadioButton boutonsCache = new JRadioButton("Caché");
        boutonsGroup.add(boutonsAuto);
        boutonsGroup.add(boutonsAffiche);
        boutonsGroup.add(boutonsCache);
        boutonsPane.add(boutons);
        boutonsPane.add(boutonsAuto);
        boutonsPane.add(boutonsAffiche);
        boutonsPane.add(boutonsCache);

        paneauCentral.add(conversionPane);
        paneauCentral.add(saisiePane);
        paneauCentral.add(diaporamaPane);
        paneauCentral.add(boutonsPane);

        JPanel validation = new JPanel();
        validation.setLayout(new FlowLayout());

        validation.add(validerBouton);
        validation.add(annulerBouton);

        paneauCentral.add(validation);

        add(paneauCentral);

    }

    private class ValiderButton extends AbstractAction {

        public ValiderButton(){
            super("Valider");
        }

        @Override
        public void actionPerformed(ActionEvent actionEvent) {
            //TODO validation des éléments ici
        }
    }

    private class AnnulerButton extends AbstractAction {

        public AnnulerButton(){
            super("Annuler");
        }

        @Override
        public void actionPerformed(ActionEvent actionEvent) {
            dispose();
        }
    }
}
